/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * Copyright (C) unfancy::labs 2008 <sya@unfancy.org>
 *
 * libuim is free software copyrighted by unfancy::labs.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name ``unfancy::labs'' nor the name of any other
 *    contributor may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * libuim IS PROVIDED BY unfancy::labs ``AS IS'' AND ANY EXPRESS
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL unfancy::labs OR ANY OTHER CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
 * BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
 
/*****************************************************************************/

#include "libuim.h"

/*****************************************************************************/

void uiml_init(void){
	/*
	init the library
	may return a context for handling multiple cons at once
	*/
}

void uiml_exit(void){
	/*
	cleanup ...
	(may take a context)
	*/
}

/*****************************************************************************/

uint32_t uiml_event_pending(void){
	/*
	check if any events are pending
	 - generated by user input
	 - thru received msgs
	*/
	return 1;
}

void uiml_event_handle(void){
	/*
	handle events, should only be called if there acutally are some 
	use like: while(event_pending()){event_handle();}
	basic functionality:
	 - recv/send msgs
	 - parse msgs
	 - handle msgs/peers (ip changes, authreqs, etc)
	 - notify user interface via callbacks
	*/
}

/*****************************************************************************/

void uiml_config_set(wchar_t* setting, wchar_t* value){
	/*
	set various config vairables
	*/
}

wchar_t* uiml_config_get(wchar_t* setting){
	/*
	get various config variables
	*/
	return 0;
}

/*****************************************************************************/

void uiml_peer_add(wchar_t* name){
	/*
	adds a peer, by looking up required info from authserver, (ip,port)
	sending an auth request to the user
	if accepted engage key exchange
	*/
}

void uiml_peer_remove(struct peer* id){
	/*
	removes a peer completly form the list
	*/
}

uint32_t uiml_peer_get_count(void){
	/*
	returns the amount of peers in the contact list
	*/
	return 0;
}

struct peer* uiml_peer_get_byid(uint32_t id){
	/*
	gets a single peer by it's id
	*/
	return 0;
}

struct peer* uiml_peer_get_byname(wchar_t* name){
	/*
	gets a peer by it's name
	*/
	return 0;
}

/*****************************************************************************/

/*void uiml_send_raw(struct pkg* mypkg){
	//fancy hax0r functionality
}*/

void uiml_send_msg(struct peer* to, wchar_t* msg){
	/*
	sends a given text msg to the specified peer
	*/
}

void uiml_send_req_keyex(struct peer* to){
	/*
	request a key exchange (ke)
	by default ke happens after either a given amount of
	data has been encrpyted w/ the same key or enough 
	time has passed
	this function allows to immediately request a ke
	*/
}
